/*
Copyright (C) 2008 Miguel Marte
miguelmarte_at_gmail.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#define _GNU_SOURCE
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>

int check_dev(int);
int get_map(int, char*);
int get_image(int, char*, int);

int main()
{
	char	name[] = "/dev/sitronix";
	char	*img_buf;
	char	*map_buf;	
	int	blockfd;
	FILE*	tmp_out;
	int	tmp;

	posix_memalign(&map_buf, getpagesize(), 65536);
	posix_memalign(&img_buf, getpagesize(), 32768);

	tmp_out = fopen("tmp_out.bin","w");
	if(tmp_out == NULL)
	{
		printf("output file could not be created\n");
		exit(-1);
	}

	blockfd = open(name, O_RDWR | O_DIRECT | O_SYNC);
        if (blockfd == -1)
	{
		printf("dev could not be opened\n");
		exit(-1);
	}

	get_map(blockfd, map_buf);

#if 0
	for(tmp = 0; tmp < 65536; tmp++)
		fputc(map_buf[tmp], tmp_out);
#endif

	get_image(blockfd, img_buf, 0);	

	for(tmp = 0; tmp < 32768; tmp++)
		fputc(img_buf[tmp], tmp_out);

	fclose(tmp_out);
	close(blockfd);

}

int check_dev(int blockfd)
{
}

int get_map(int blockfd, char* map_buf)
{
	char	*get_map;
	int	tmp;

	posix_memalign(&get_map, getpagesize(), 512);

	for (tmp = 0; tmp < 512; tmp++)
	{
		get_map[tmp] = 0;
	}

	get_map[0] = 0x04;
	get_map[5] = 0x01;

	lseek(blockfd, 25088, SEEK_SET);
	if(write(blockfd, get_map, 512) == -1)
		perror("write");

	lseek(blockfd, 45056, SEEK_SET);
	if(read(blockfd, map_buf, 65536) == -1)
		perror("read");
}

int get_image(int blockfd, char* img_buf, int select)
{
	char 	*get_img;
	int	tmp;

	posix_memalign(&get_img, getpagesize(), 512);

	for (tmp = 0; tmp < 512; tmp++)
	{
		get_img[tmp] = 0;
	}

	get_img[0] = 0x04;
	get_img[4] = 0x02 + select;

	lseek(blockfd, 25088, SEEK_SET);
	if(write(blockfd, get_img, 512) == -1)
		perror("write");

	lseek(blockfd, 45056, SEEK_SET);
	if(read(blockfd, img_buf, 32768) == -1)
		perror("read");
}

